_**Маяк на основе телеграфного трансивера Super RM или Super Octopus или RockMite51. 
Разработал Игорь Кутко, UA3YMC, 27 июня 2019г.**_

Изначальной причиной, по которой мне пришлось написать этот код, стало то, 
что оригинальный функционал трансивера был крайне отвратительным.
При неплохой аппаратной реализации программное обеспечение было просто ужасным.
У телеграфного ключа трансивера отсутствовали повторы точек и тире, что делало практически невозможным работу 
телеграфом в ручном режиме. Работа с компьютера была возможна только через специализированное ПО которое, 
ко всему, было на китайском языке. Данные обстоятельства и побудили меня к написанию данного кода.

В оригинале использовался микроконтроллер ST12C4052AD, но мне не удалось найти для него
необходимой документации, поэтому я решил заменить его на другой, более удобный для меня, микроконтроллер ATTiny4313.
Данный микроконтроллер практически полностью совпадает по пинам с ST12C4052AD, но RESET у него 
осуществляется по другому, поэтому в схему трансивера необходимо внести небольшие изменения, 
удалив с платы конденсатор Е1 и резистор R27.

Так же, ввиду того, что я не смог напрямую управлять портом B0(pin 12), мне пришлось сделать
аппаратный костыль, соединив на плате 9 и 12 ножки микроконтроллера, и производить управление портом D5 (pin 9).
Данный костыль так же позволяет отключать передачу в эфир, если сделать перемычку через дополнительный тумблер.

Функционал:
В данной прошивке реализован автоматический телеграфный ключ с регулировкой тона и скорости передачи.
Ключ имеет 8 тонов и 10 скоростей. Частота тона выбиралась из соображений благозвучности и возможности 
комфортного и длительного восприятия. Диапазон скоростей ориентирован на среднестатистического радиолюбителя.
В режиме маяка трансивер автоматически передает сообщение заранее записанное в EEPROM микроконтроллера.
Запуск и останов режима маяка осуществляются только кнопкой с передней панели. Изменение сообщения в EEPROM 
возможна только через программатор. Запись сообщения происходит в пустой файл EEPROM-а с помощью любого HEX редактора
в ASCII кодировке в верхнем регистре. Затем файл прошивается в микроконтроллер.

_avrdude -p t4313 -P /dev/ttyUSB0 -c avrisp -b 19200 -U eeprom:w:message.hex_

Перечень передаваемых символов смотри в коде.
В режиме терминала трансивер передает сообщения, полученные через RS232 порт, что позволяет его использовать без 
дополнительного ПО на любой операционной системе. Передача сообщений происходит построчно строками длинной до 70 символов 
верхнего или нижнего регистра. При передаче строки текста трансивер возвращает эхом принятую строку и, по окончанию передачи строки
в эфир, выводит в терминал сообщение "ОК". В режиме маяка в терминал будут поступать сообщения счетчика количества передач
вида "#n", где n-число от 0 до 65534.

Скорость порта RS232, а так же режим скорости передачи по умолчанию, тон по умолчанию, паузу между повторами можно изменить по 
своему усмотрению в коде, ищите соответствующие комментарии.

Код написан в среде Arduino IDE v 1.8.5
Использовано ядро ATTinyCore by Spence Konde
Для установки ядра необходимо сделать следующее:
Зайти в Arduino IDE: Файл -> Настройки -> Дополнительные ссылки для менеджера плат. 
Ввести http://drazzy.com/package_drazzy.com_index.json
Зайти: Инструменты -> Плата -> Менеджер плат. В строке поиска ввести ATTinyCore
Найти ATTinyCore by Spence Konde и установить.
Перед прошивкой необходимо сконфигурировать фьюзы микроконтроллера.
Конфигурация фьюзов (E:FF, H:DF, L:EF)

_avrdude -p t4313 -P /dev/ttyUSB0 -c avrisp -b 19200 -U lfuse:w:0xEF:m  -U hfuse:w:0xDF:m  -U efuse:w:0xFF:m_

Компиляцию производить со следующими параметрами:
Плата 	ATTiny2313/4313
Chip 	4313
Clock 	11.0592
LTO 	Enabled
